<?php
require_once(__DIR__ . '/../../require.php');

if ($_SERVER['REQUEST_METHOD'] === 'GET') {
	$id = $_GET['id'] ?? '';
	if (!strlen($id) || validate_register_id($id)) { return on_error(400, ['不正なリクエスト。']); }

	$users = load_users();
	if (!isset($users[$id])) { return on_error(400, ['存在しない ID']); }

	$view['user'] = $users[$id];
	$users = null;

	$profile = load_profile($id);
	$bio = $profile['bio'] ?? '';
	$bio = url_to_link(nl2br(htmlspecialchars($bio), false));
	$view['bio'] = $bio;
	$profile = null;

	$page = max(1, $_GET['page'] ?? 0);
	$result = search_post([
		'key' => 'userid',
		'value' => $id,
		'page' => $page,
		'pagesize' => POSTS_PER_PAGE,
		'pager_prefix' => "?id={$id}&page=",
	]);
	$view['post_list'] = $result['post_list'];
	$view['post_count'] = $result['total'];
	$view['pager'] = $result['pager'];
	$result = null;

	output_html($view, ['header.php', 'user.php', 'post-list.php', 'pager.php']);
}
